// Copyright (c) 2023 Dominic Masters
// 
// This software is released under the MIT License.
// https://opensource.org/licenses/MIT

#include "PrefabAssetParser.hpp"

using namespace Dawn;

std::vector<std::string> PrefabAssetParser::getRequiredAttributes() {
  return { "type", "name" };
}

std::map<std::string, std::string> PrefabAssetParser::getOptionalAttributes() {
  return { };
}

int32_t PrefabAssetParser::onParse(
  Xml *node,
  std::map<std::string, std::string> values,
  struct PrefabAsset *out,
  std::string *error
) {
  out->fileName = values["name"];
  
  if(values["type"] == "texture") {
    out->type = PREFAB_ASSET_TYPE_TEXTURE;
  } else {
    *error = "Unknown asset type '" + values["type"] + "'";
    return 1;
  }
  
  return 0;
}