// Copyright (c) 2023 Dominic Masters
// 
// This software is released under the MIT License.
// https://opensource.org/licenses/MIT

#pragma once
#include "util/XmlParser.hpp"

namespace Dawn {
  enum PrefabAssetType {
    PREFAB_ASSET_TYPE_TEXTURE
  };

  struct PrefabAsset {
    PrefabAssetType type;
    std::string fileName;
    std::string usageName;
  };

  class PrefabAssetParser : public XmlParser<PrefabAsset> {
    public:
      virtual std::vector<std::string> getRequiredAttributes();
      virtual std::map<std::string, std::string> getOptionalAttributes();

      virtual int32_t onParse(
        Xml *node,
        std::map<std::string, std::string> values,
        struct PrefabAsset *out,
        std::string *error
      );
  };
}